import java.applet.*;
import java.awt.*;

public class Integral extends Applet {
  final double A = 0;
  final double B = Math.PI * Math.PI / 96;
  int w, h;
  public boolean mouseDown(Event e, int x, int y)
  {
    Graphics g = getGraphics();
       
    g.setColor(Color.white);
    g.fillRect(0, h - 44, w, 45);

    if (x < 11 || x > w - 20)
      return true;

    g.setColor(Color.black);

    double b = A + (x - 10) * (B - A) / (w - 30);
    Integrator integ = new Integrator(A, b);
    String res = new String("Integral(A, X) = ");
    res = res.concat(Double.toString(integ.Integrate()));
    g.drawString(res, 10, h - 5);

    String res2 = new String("X = ");
    res2 = res2.concat(Double.toString(b));
    g.drawString(res2, 10, h - 29);

    String res3 = new String("F(X) = ");
    res3 = res3.concat(Double.toString(integ.Function(b)));
    g.drawString(res3, 10, h - 17);

    return true;
  }
  public void paint(Graphics g)
  {
    Integrator integ = new Integrator(A, B);
    Dimension r = size();
    w = r.width;
    h = r.height;
    double inc = (B - A) / (r.width - 30);
    double x = A, y, scale = r.height - 60;
    double sum = 0, last_sum;
    int x1, x2, y1, y2;
    Polygon p = new Polygon();
  
    g.setColor(Color.white);
    g.fillRect(0, 0, w, h);
    g.setColor(Color.black);
    g.drawLine(10, 10, 10, h - 50);
    g.drawLine(10, h - 50, w - 10, h - 50);
    g.drawLine(10, 10, 5, 15);
    g.drawLine(10, 10, 15, 15);
    g.drawLine(w - 10, h - 50, w - 15, h - 55);
    g.drawLine(w - 10, h - 50, w - 15, h - 45);

    g.setColor(Color.red);
    for (int i = 0; i < w - 30; i++)
    {
      y = integ.Function(x);
      p.addPoint(i + 11, h - 51 - (int)(y * scale));
      if ((i & 15) == 15)
      {
        g.setColor(Color.blue);
        g.drawLine(i + 11, h - 51 - (int)(y * scale), i + 11, h - 51);
        g.setColor(Color.red);
      }
      x += inc;
      Integrator in = new Integrator(A, A + x);
      last_sum = sum;
      sum += in.Integrate();
      g.drawLine(i + 10, h - 51 - (int)(last_sum * scale), i + 11, h - 51 - (int)(sum * scale));
    }
    p.addPoint(w - 20, h - 51);
    p.addPoint(11, h - 51);
    g.setColor(Color.blue);
    g.drawPolygon(p);
  }
}

abstract class AbstractIntegrator {
  final int n = 100;
  double a, b;
  abstract double Function(double x);
  double Integrate()
  {
    double s = 0;
    double last_f = Math.abs(Function(a)), cur_f;
    double h = (b - a) / n;
    double pos = a + h;

    for (int i = 1; i < n; i++, pos += h)
    {
      cur_f = Math.abs(Function(pos));
      s += cur_f * h + (last_f - cur_f) * h / 2;
      last_f = cur_f;
    }

    return s;
  }
  public AbstractIntegrator(double ai, double bi)
  {
    if (a > b)
    {
      a = bi;
      b = ai;
    }
    else
    {
      a = ai;
      b = bi;
    }
  }
}

class Integrator extends AbstractIntegrator {
  public Integrator(double ai, double bi)
  {
    super(ai, bi);
  }
  double Function(double x)
  {
    return Math.tan(Math.sqrt(6 * x));
  }
}
